From b6c5ea72339b88c53bbddc542fbc657439f42d20 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 17 2020 07:15:48 +0000
Subject: [PATCH 147/2232] Add Rust fallible test functions


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index c709678..07221c2 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -1,4 +1,5 @@
 use cxx::{CxxString, UniquePtr};
+use std::fmt::{self, Display};
 
 #[cxx::bridge(namespace = tests)]
 pub mod ffi {
@@ -52,11 +53,25 @@ pub mod ffi {
         fn r_take_str(s: &str);
         fn r_take_rust_string(s: String);
         fn r_take_unique_ptr_string(s: UniquePtr<CxxString>);
+
+        fn r_try_return_primitive() -> Result<usize>;
+        fn r_fail_return_primitive() -> Result<usize>;
     }
 }
 
 pub type R = usize;
 
+#[derive(Debug)]
+struct Error;
+
+impl std::error::Error for Error {}
+
+impl Display for Error {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        f.write_str("rust error")
+    }
+}
+
 fn r_return_primitive() -> usize {
     2020
 }
@@ -131,3 +146,11 @@ fn r_take_rust_string(s: String) {
 fn r_take_unique_ptr_string(s: UniquePtr<CxxString>) {
     assert_eq!(s.as_ref().unwrap().to_str().unwrap(), "2020");
 }
+
+fn r_try_return_primitive() -> Result<usize, Error> {
+    Ok(2020)
+}
+
+fn r_fail_return_primitive() -> Result<usize, Error> {
+    Err(Error)
+}
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 350cd7d..0ec2658 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -1,5 +1,6 @@
 #include "tests/ffi/tests.h"
 #include "tests/ffi/lib.rs"
+#include <cstring>
 
 extern "C" void cxx_test_suite_set_correct() noexcept;
 extern "C" tests::R *cxx_test_suite_get_box() noexcept;
@@ -126,6 +127,14 @@ extern "C" const char *cxx_run_test() noexcept {
   r_take_unique_ptr_string(
       std::unique_ptr<std::string>(new std::string("2020")));
 
+  ASSERT(r_try_return_primitive() == 2020);
+  try {
+    r_fail_return_primitive();
+    ASSERT(false);
+  } catch (const rust::Error &e) {
+    ASSERT(std::strcmp(e.what(), "rust error") == 0);
+  }
+
   cxx_test_suite_set_correct();
   return nullptr;
 }

